#!/opt/local/bin/perl -w
use strict;
use warnings;
#use Date::Calc qw(Day_of_Week Week_Number Day_of_Year);
use Time::Piece;

my ($date, $author, $comment, $Setsumei, $count_art) = (0, 0, 0, 0, 0);
my (@date);
my ($title, $author_list);
my ($URLastro, $URL, $name, $com) = ("http://xxx.yukawa.kyoto-u.ac.jp", "", "", "");
#my ($files_path) = ("/home/yamamoto/public_html/astro-ph/files.html");
my ($files_path) = ("files.html");

my %month =(
	Jan => 1,
	Feb => 2,
	Mar => 3,
	Apr => 4,
	May => 5,
	Jun => 6,
	Jul => 7,
	Aug => 8,
	Sep => 9,
	Oct => 10,
	Nov => 11,
	Dec => 12,
	);

my %day =(
	Mon => '月',
	Tue => '火',
	Wed => '水',
	Thu => '木',
	Fri => '金',
	);

my %file =(
	Mon => 'files/Mon.tex',
	Tue => 'files/Tue.tex',
	Wed => 'files/Wed.tex',
	Thu => 'files/Thu.tex',
	Fri => 'files/Fri.tex',
	);

my @tantoh = (
	'佐々木',
	'松尾',
	'山本',
	'小野',
	'野津',
	'森本',
	'横山',
	);

no strict 'refs';
*{"Time::Piece::real_week"} = \&real_week;
print "make page\n";


open TEX, ">temp.tex" or die "$!\n";
open HTMLFILE, ">$files_path" or die "$!\n";
{
	print HTMLFILE "
<!DOCTYPE html>
<html lang=\"ja\">
<head>
<meta charset=\"UTF-8\">
<meta name=\"description\" content=\"\">
<title>Astro-ph/Science/Nature</title>
</head>
	
<body>
<div id=\"files\">
	<p>要約ファイル</p>
	<ul>
		<li>
";
}

sub real_week {
    my $self = shift;
    my $new_year = sprintf('%04d-01-01', $self->year);
    my $margin = Time::Piece->strptime($new_year, '%Y-%m-%d')->day_of_week;
    return int((($self->yday + $margin) / 7) + 1);
}
sub check {
#	my $_[0] = shift(@_);
		$_[0] =~ s|&#x27;|'|g;
		$_[0] =~ s|%|\\%|g;
		$_[0] =~ s|&quot;|\"|g;
		$_[0] =~ s|&amp;|\\&|g;
		$_[0] =~ s|&lt;|<|g;
		$_[0] =~ s|&gt;|>|g;
		$_[0] =~ s|&#xb0;|{\\textdegree}|ig;
		$_[0] =~ s|&#xb1;|{\\pm}|ig;
		$_[0] =~ s|&#xb2;|{^2}|ig;
		$_[0] =~ s|&#xb3;|{^3}|ig;
		$_[0] =~ s|&#xb4;|{\\textasciiacute}|ig;
		$_[0] =~ s|&#xb5;|\${\\mathrm{\\mu}}\$|ig;
		$_[0] =~ s|&#xb6;|{\\textparagraph}|ig;
		$_[0] =~ s|&#xb7;|{\\cdot}|ig;
		$_[0] =~ s|&#xb8;|\\c{}|ig;
		$_[0] =~ s|&#xb9;|{^1}|ig;
		$_[0] =~ s|&#xba;|{\\textordmasculine}|ig;
		$_[0] =~ s|&#xbb;|{\\guillemotright}|ig;
		$_[0] =~ s|&#xbc;|{\\textonequarter}|ig;
		$_[0] =~ s|&#xbd;|{\\textonehalf}|ig;
		$_[0] =~ s|&#xbe;|{\\textthreequarters}|ig;
		$_[0] =~ s|&#xbf;|{\\textquestiondown}|ig;
		$_[0] =~ s|&#xc0;|\\\`{A}|ig;
		$_[0] =~ s|&#xc1;|\\\'{A}|ig;
		$_[0] =~ s|&#xc2;|\\\^{A}|ig;
		$_[0] =~ s|&#xc3;|\\\~{A}|ig;
		$_[0] =~ s|&#xc4;|\\\"{A}|ig;
		$_[0] =~ s|&#xc5;|{\\AA}|ig;
		$_[0] =~ s|&#xc6;|{\\AE}|ig;
		$_[0] =~ s|&#xc7;|\\c{C}|ig;
		$_[0] =~ s|&#xc8;|\\\`{E}|ig;
		$_[0] =~ s|&#xc9;|\\\'{E}|ig;
		$_[0] =~ s|&#xca;|\\\^{E}|ig;
		$_[0] =~ s|&#xcb;|\\\"{E}|ig;
		$_[0] =~ s|&#xcc;|\\\`{I}|ig;
		$_[0] =~ s|&#xcd;|\\\'{I}|ig;
		$_[0] =~ s|&#xce;|\\\^{I}|ig;
		$_[0] =~ s|&#xcf;|\\\"{I}|ig;
		$_[0] =~ s|&#xd0;|{\\DH}|ig;
		$_[0] =~ s|&#xd1;|\\\~{N}|ig;
		$_[0] =~ s|&#xd2;|\\\`{O}|ig;
		$_[0] =~ s|&#xd3;|\\\'{O}|ig;
		$_[0] =~ s|&#xd4;|\\\^{O}|ig;
		$_[0] =~ s|&#xd5;|\\\~{O}|ig;
		$_[0] =~ s|&#xd6;|\\\"{O}|ig;
		$_[0] =~ s|&#xd7;|{\\texttimes}|ig;
		$_[0] =~ s|&#xd8;|{\\O}|ig;
		$_[0] =~ s|&#xd9;|\\\`{U}|ig;
		$_[0] =~ s|&#xda;|\\\'{U}|ig;
		$_[0] =~ s|&#xdb;|\\\^{U}|ig;
		$_[0] =~ s|&#xdc;|\\\"{U}|ig;
		$_[0] =~ s|&#xdd;|\\\'{Y}|ig;
		$_[0] =~ s|&#xde;|{\\TH}|ig;
		$_[0] =~ s|&#xdf;|{\\ss}|ig;
		$_[0] =~ s|&#xe0;|\\\`{a}|ig;
		$_[0] =~ s|&#xe1;|\\\'{a}|ig;
		$_[0] =~ s|&#xe2;|\\\^{a}|ig;
		$_[0] =~ s|&#xe3;|\\\~{a}|ig;
		$_[0] =~ s|&#xe4;|\\\"{a}|ig;
		$_[0] =~ s|&#xe5;|{\\aa}|ig;
		$_[0] =~ s|&#xe6;|{\\ae}|ig;
		$_[0] =~ s|&#xe7;|\\c{c}|ig;
		$_[0] =~ s|&#xe8;|\\\`{e}|ig;
		$_[0] =~ s|&#xe9;|\\\'{e}|ig;
		$_[0] =~ s|&#xea;|\\\^{e}|ig;
		$_[0] =~ s|&#xeb;|\\\"{e}|ig;
		$_[0] =~ s|&#xec;|\\\`{i}|ig;
		$_[0] =~ s|&#xed;|\\\'{i}|ig;
		$_[0] =~ s|&#xee;|\\\^{i}|ig;
		$_[0] =~ s|&#xef;|\\\"{i}|ig;
		$_[0] =~ s|&#xf0;|{\\dh}|ig;
		$_[0] =~ s|&#xf1;|\\\~{n}|ig;
		$_[0] =~ s|&#xf2;|\\\`{o}|ig;
		$_[0] =~ s|&#xf3;|\\\'{o}|ig;
		$_[0] =~ s|&#xf4;|\\\^{o}|ig;
		$_[0] =~ s|&#xf5;|\\\~{o}|ig;
		$_[0] =~ s|&#xf6;|\\\"{o}|ig;
		$_[0] =~ s|&#xf7;|{\\div}|ig;
		$_[0] =~ s|&#xf8;|{\\o}|ig;
		$_[0] =~ s|&#xf9;|\\\`{u}|ig;
		$_[0] =~ s|&#xfa;|\\\'{u}|ig;
		$_[0] =~ s|&#xfb;|\\\^{u}|ig;
		$_[0] =~ s|&#xfc;|\\\"{u}|ig;
		$_[0] =~ s|&#xfd;|\\\'{y}|ig;
		$_[0] =~ s|&#xfe;|{\\th}|ig;
		$_[0] =~ s|&#xff;|\\\"{y}|ig;
		$_[0] =~ s|&#x100;|\\\={A}|ig;
		$_[0] =~ s|&#x101;|\\\={a}|ig;
		$_[0] =~ s|&#x102;|\\u{A}|ig;
		$_[0] =~ s|&#x103;|\\u{a}|ig;
		$_[0] =~ s|&#x104;|\\k{A}|ig;
		$_[0] =~ s|&#x105;|\\k{a}|ig;
		$_[0] =~ s|&#x106;|\\'{C}|ig;
		$_[0] =~ s|&#x107;|\\'{c}|ig;
		$_[0] =~ s|&#x108;|\\\^{C}|ig;
		$_[0] =~ s|&#x109;|\\\^{c}|ig;
		$_[0] =~ s|&#x10a;|\\\.{C}|ig;
		$_[0] =~ s|&#x10b;|\\\.{c}|ig;
		$_[0] =~ s|&#x10c;|\\v{C}|ig;
		$_[0] =~ s|&#x10d;|\\v{c}|ig;
		$_[0] =~ s|&#x10e;|\\v{D}|ig;
		$_[0] =~ s|&#x10f;|\\v{d}|ig;
		$_[0] =~ s|&#x110;|{\\DJ}|ig;
		$_[0] =~ s|&#x111;|{\\dj}|ig;
		$_[0] =~ s|&#x112;|\\\={E}|ig;
		$_[0] =~ s|&#x113;|\\\={e}|ig;
		$_[0] =~ s|&#x114;|\\u{E}|ig;
		$_[0] =~ s|&#x115;|\\u{e}|ig;
		$_[0] =~ s|&#x116;|\\\.{E}|ig;
		$_[0] =~ s|&#x117;|\\\.{e}|ig;
		$_[0] =~ s|&#x118;|\\k{E}|ig;
		$_[0] =~ s|&#x119;|\\k{e}|ig;
		$_[0] =~ s|&#x11a;|\\v{E}|ig;
		$_[0] =~ s|&#x11b;|\\v{e}|ig;
		$_[0] =~ s|&#x11c;|\\\^{G}|ig;
		$_[0] =~ s|&#x11d;|\\\^{g}|ig;
		$_[0] =~ s|&#x11e;|\\u{G}|ig;
		$_[0] =~ s|&#x11f;|\\u{g}|ig;
		$_[0] =~ s|&#x120;|\\\.{G}|ig;
		$_[0] =~ s|&#x121;|\\\.{g}|ig;
		$_[0] =~ s|&#x122;|\\c{G}|ig;
		$_[0] =~ s|&#x123;|\\c{g}|ig;
		$_[0] =~ s|&#x124;|\\\^{H}|ig;
		$_[0] =~ s|&#x125;|\\\^{h}|ig;
		$_[0] =~ s|&#x126;|{\\fontencoding{LELA}\\selectfont\\char40}|ig;
		$_[0] =~ s|&#x127;|{\\Elzxh}|ig;
		$_[0] =~ s|&#x128;|\\\~{I}|ig;
		$_[0] =~ s|&#x129;|\\\~{\\i}|ig;
		$_[0] =~ s|&#x12a;|\\\={I}|ig;
		$_[0] =~ s|&#x12b;|\\\={\\i}|ig;
		$_[0] =~ s|&#x12c;|\\u{I}|ig;
		$_[0] =~ s|&#x12d;|\\u{\\i}|ig;
		$_[0] =~ s|&#x12e;|\\k{I}|ig;
		$_[0] =~ s|&#x12f;|\\k{i}|ig;
		$_[0] =~ s|&#x130;|\\\.{I}|ig;
		$_[0] =~ s|&#x131;|{\\i}|ig;
		$_[0] =~ s|&#x132;|{IJ}|ig;
		$_[0] =~ s|&#x133;|{ij}|ig;
		$_[0] =~ s|&#x134;|\\\^{J}|ig;
		$_[0] =~ s|&#x135;|\\\^{\\j}|ig;
		$_[0] =~ s|&#x136;|\\c{K}|ig;
		$_[0] =~ s|&#x137;|\\c{k}|ig;
		$_[0] =~ s|&#x138;|{\\fontencoding{LELA}\\selectfont\\char91}|ig;
		$_[0] =~ s|&#x139;|\\'{L}|ig;
		$_[0] =~ s|&#x13a;|\\'{l}|ig;
		$_[0] =~ s|&#x13b;|\\c{L}|ig;
		$_[0] =~ s|&#x13c;|\\c{l}|ig;
		$_[0] =~ s|&#x13d;|\\v{L}|ig;
		$_[0] =~ s|&#x13e;|\\v{l}|ig;
		$_[0] =~ s|&#x13f;|{\\fontencoding{LELA}\\selectfont\\char201}|ig;
		$_[0] =~ s|&#x140;|{\\fontencoding{LELA}\\selectfont\\char202}|ig;
		$_[0] =~ s|&#x141;|{\\L}|ig;
		$_[0] =~ s|&#x142;|{\\l}|ig;
		$_[0] =~ s|&#x143;|\\'{N}|ig;
		$_[0] =~ s|&#x144;|\\'{n}|ig;
		$_[0] =~ s|&#x145;|\\c{N}|ig;
		$_[0] =~ s|&#x146;|\\c{n}|ig;
		$_[0] =~ s|&#x147;|\\v{N}|ig;
		$_[0] =~ s|&#x148;|\\v{n}|ig;
		$_[0] =~ s|&#x149;|{\\'l}|ig;
		$_[0] =~ s|&#x14a;|{\\NG}|ig;
		$_[0] =~ s|&#x14b;|{\\ng}|ig;
		$_[0] =~ s|&#x14c;|\\\={O}|ig;
		$_[0] =~ s|&#x14d;|\\\={o}|ig;
		$_[0] =~ s|&#x14e;|\\u{O}|ig;
		$_[0] =~ s|&#x14f;|\\u{o}|ig;
		$_[0] =~ s|&#x150;|\\H{O}|ig;
		$_[0] =~ s|&#x151;|\\H{o}|ig;
		$_[0] =~ s|&#x152;|{\\OE}|ig;
		$_[0] =~ s|&#x153;|{\\oe}|ig;
		$_[0] =~ s|&#x154;|\\'{R}|ig;
		$_[0] =~ s|&#x155;|\\'{n}|ig;
		$_[0] =~ s|&#x156;|\\c{R}|ig;
		$_[0] =~ s|&#x157;|\\c{r}|ig;
		$_[0] =~ s|&#x158;|\\v{R}|ig;
		$_[0] =~ s|&#x159;|\\v{r}|ig;
		$_[0] =~ s|&#x15a;|\\'{S}|ig;
		$_[0] =~ s|&#x15b;|\\'{s}|ig;
		$_[0] =~ s|&#x15c;|\\\^{S}|ig;
		$_[0] =~ s|&#x15d;|\\\^{s}|ig;
		$_[0] =~ s|&#x15e;|\\c{S}|ig;
		$_[0] =~ s|&#x15f;|\\c{s}|ig;
		$_[0] =~ s|&#x160;|\\v{S}|ig;
		$_[0] =~ s|&#x161;|\\v{s}|ig;
		$_[0] =~ s|&#x162;|\\c{T}|ig;
		$_[0] =~ s|&#x163;|\\c{t}|ig;
		$_[0] =~ s|&#x164;|\\v{T}|ig;
		$_[0] =~ s|&#x165;|\\v{t}|ig;
		$_[0] =~ s|&#x166;|{\\fontencoding{LELA}\\selectfont\\char47}|ig;
		$_[0] =~ s|&#x167;|{\\fontencoding{LELA}\\selectfont\\char63}|ig;
		$_[0] =~ s|&#x168;|\\\~{U}|ig;
		$_[0] =~ s|&#x169;|\\\~{u}|ig;
		$_[0] =~ s|&#x16a;|\\\={U}|ig;
		$_[0] =~ s|&#x16b;|\\\={u}|ig;
		$_[0] =~ s|&#x16c;|\\u{U}|ig;
		$_[0] =~ s|&#x16d;|\\u{u}|ig;
		$_[0] =~ s|&#x16e;|\\r{U}|ig;
		$_[0] =~ s|&#x16f;|\\r{u}|ig;
		$_[0] =~ s|&#x170;|\\H{U}|ig;
		$_[0] =~ s|&#x171;|\\H{u}|ig;
		$_[0] =~ s|&#x172;|\\k{U}|ig;
		$_[0] =~ s|&#x173;|\\k{u}|ig;
		$_[0] =~ s|&#x174;|\\\^{W}|ig;
		$_[0] =~ s|&#x175;|\\\^{w}|ig;
		$_[0] =~ s|&#x176;|\\\^{Y}|ig;
		$_[0] =~ s|&#x177;|\\\^{y}|ig;
		$_[0] =~ s|&#x178;|\\\"{Y}|ig;
		$_[0] =~ s|&#x179;|\\'{Z}|ig;
		$_[0] =~ s|&#x17a;|\\'{z}|ig;
		$_[0] =~ s|&#x17b;|\\\.{Z}|ig;
		$_[0] =~ s|&#x17c;|\\\.{z}|ig;
		$_[0] =~ s|&#x17d;|\\v{Z}|ig;
		$_[0] =~ s|&#x17e;|\\v{z}|ig;
		$_[0] =~ s|&#x3b0:|\\acute{\\ddot{\\upsilon}}|ig;
		$_[0] =~ s|&#x3b1;|\\alpha|ig;
		$_[0] =~ s|&#x3b2;|\\beta|ig;
		$_[0] =~ s|&#x3b3;|\\gamma|ig;
		$_[0] =~ s|&#x3b4;|\\delta|ig;
		$_[0] =~ s|&#x3b5;|\\epsilon|ig;
		$_[0] =~ s|&#x3b6;|\\zeta|ig;
		$_[0] =~ s|&#x3b7;|\\eta|ig;
		$_[0] =~ s|&#x3b8;|\\texttheta|ig;
		$_[0] =~ s|&#x3b9;|\\iota|ig;
		$_[0] =~ s|&#x3ba;|\\kappa|ig;
		$_[0] =~ s|&#x3bb;|\\lambda|ig;
		$_[0] =~ s|&#x3bc;|\\mu|ig;
		$_[0] =~ s|&#x3bd;|\\nu|ig;
		$_[0] =~ s|&#x3be;|\\xi|ig;
		$_[0] =~ s|&#x3bf;|\\o|ig;
		$_[0] =~ s|&#x3c0;|\\pi|ig;
		$_[0] =~ s|&#x3c1;|\\rho|ig;
		$_[0] =~ s|&#x3c2;|\\varsigma|ig;
		$_[0] =~ s|&#x3c3;|\\sigma|ig;
		$_[0] =~ s|&#x3c4;|\\tau|ig;
		$_[0] =~ s|&#x3c5;|\\upsilon|ig;
		$_[0] =~ s|&#x3c6;|\\varphi|ig;
		$_[0] =~ s|&#x3c7;|\\chi|ig;
		$_[0] =~ s|&#x3c8;|\\psi|ig;
		$_[0] =~ s|&#x3c9;|\\omega|ig;
		$_[0] =~ s|&#x3ca;|\\ddot{\\iota}|ig;
		$_[0] =~ s|&#x3cb;|\\ddot{\\upsilon}|ig;
		$_[0] =~ s|&#x3cc;|\\'{o}|ig;
		$_[0] =~ s|&#x3cd;|\\acute{\\upsilon}|ig;
		$_[0] =~ s|&#x3ce;|\\acute{\\omega}|ig;
		$_[0] =~ s|&(.*?);||g and print STDERR "====>" .$1;
	
}


########################################################

while(<>){
	m|<h3>(.*?)</h3>| and print "\n\n%%%%%%%%%%%%%%%%%%%%%%%% $1 %%%%%%%%%%%%%%%%%%%%%%%%%\n" and $date=1;
	if($date==1 and (@date = split /[\s,]+/, $1)){
		my $filename = $file{$date[0]};
		$filename =~ s|\.tex|sprintf("%02d%02d.tex",$month{$date[2]},$date[1])|ge;
		open TEX, ">".$filename or die "$!\n";
		my $tempdate = $date[3]."-".$month{$date[2]}."-".$date[1];
		my $tempday = Time::Piece->strptime($tempdate,"%Y-%m-%d");
		my $week_num = $tempday->real_week;
		my $week_day = $tempday->_wday;
		printf HTMLFILE "<p><a href=\"%s\">%s曜日::</a>%02d/%02d::担当[%s]::"
		,$filename,$day{$date[0]},$month{$date[2]},$date[1],$tantoh[ ($week_num*5 + $week_day + 3)%7 ];
		printf ">%s曜日::%02d/%02d %d %d ::担当[%s]::"
		,$day{$date[0]},$month{$date[2]},$date[1],$week_num ,$week_day,$tantoh[ ($week_num*5 + $week_day + 3)%7 ];
		print TEX "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% $day{$date[0]}曜日用
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\\Day{月を書いてください}{日にちを書いてください}{$day{$date[0]}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\\Day{$month{$date[2]}}{$date[1]}{$day{$date[0]}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\\AID{ArxiveのIDを入れる(ex. 1234.5678)  空白を置かないように注意！}
%\\Dai{タイトル}
%\\Chosha{著者}
%\\Comments{コメント}
%\\Subjects{ex. Earth and Planetary Astrophysics (astro-ph.EP)}
%\\Setsumei{理論, 観測, 実験 etc.}
%{
%	コメント
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
		$date=0;
		$count_art=0;
	}
# abs
	m|/abs/(\d{4}\.\d{4})| and print TEX "\n\\AID{$1}"."\n";
# title
	if(m|Title:</span> (.+)$|){
		$title = $1;
		&check($title);
		$title =~ s|\\\\\&|\\\&|g;
		print TEX "\\Dai{$title}\n";
	}
# author	
	if(m|<span class="descriptor">Authors:</span>|){
		$author = 1;
		$author_list = "\\Chosha{";
	}
	if($author == 1){
		if(m|<a href=\"(.*?)\">(.*)</a>|){
			$URL = $URLastro.$1;
			$name = $2;
			&check($name);
			&check($URL);
			$author_list .= "\\href{".$URL."}{".$name."}, ";
		}
	}
	if($author == 1 and m|</div>|){
		$author_list =~ s|}, $|}|g;
		$author_list .= "}\n";
		print TEX $author_list;
		$author = 0;
	}
# comment
	m|Comments:</span>| and $comment = 1 and print TEX "\\Comments{";
	if($comment == 1 and m|</span> (.*$)|){
		$com = $1;
		$com =~ s|<a href=\"(.*?)\">(.*?)</a>|\\href{$1}{$2}|ig;
		$com =~ s|&amp;|\\&|g;
		$com =~ s|%|\\%|g;
		print TEX $com." ";
	}
	$comment == 1 and m|</div>| and print TEX "}\n" and $comment = 0;
# Subject
	m|Subjects:</span>| and m|<span class=\"primary-subject\">(.*?)</span>(.*$)| and print TEX "\\Subjects{$1$2}\n";

# footer
	m|<dd>| and $Setsumei = 1;
	$Setsumei == 1 and m|</dd>| and print TEX "\\Setsumei{理論/観測/実験 etc....}\n{\n\tComment!!!!\n}\n"
					and $count_art++ and $Setsumei = 0;
# count
	m|</dl>| and print "article ($count_art)\n" and print HTMLFILE "論文数($count_art)</p>" ;
}

print HTMLFILE "
		</li>
		</ul>
	</div>
</body>

</html>";
